// adf7242Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "adf7242.h"
#include "adf7242Dlg.h"
#include <windows.h>
#include <winioctl.h>
#include "ezusbsys.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void ReadUSBThread();
unsigned char read_flag=1;
CString Newdata;
//HANDLE hReadThread = NULL;
FILE *fp = NULL;
HANDLE m_hDevice;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAdf7242Dlg dialog

CAdf7242Dlg::CAdf7242Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAdf7242Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAdf7242Dlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAdf7242Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAdf7242Dlg)
	DDX_Control(pDX, IDC_EDIT_DATA, m_Data);
	DDX_Control(pDX, IDC_EDIT_PATH, m_Path);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAdf7242Dlg, CDialog)
	//{{AFX_MSG_MAP(CAdf7242Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAdf7242Dlg message handlers

BOOL CAdf7242Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_Path.SetWindowText("c:\\ADF7242_DATA.txt");
	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAdf7242Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAdf7242Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
//m_Data.SetWindowText(Newdata);
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAdf7242Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void ReadUSBData()
{

	BULK_TRANSFER_CONTROL bulkTranCtrl;	
	BOOL revRst;
	unsigned long nBytes;    //ʵʽյݵĸ
	unsigned char gDataRevBuffer[512];
	unsigned char i;

	bulkTranCtrl.pipeNum = 2;
	
		revRst = DeviceIoControl(			
		m_hDevice,			
		IOCTL_EZUSB_BULK_READ,			
		(PVOID)&bulkTranCtrl,			
		sizeof(BULK_TRANSFER_CONTROL),			
		gDataRevBuffer,			
		512,			
		&nBytes,			
		NULL			
		);
		if (revRst)      //ճɹ			
		{
			Newdata.Format("%x",gDataRevBuffer[510]);
			
			for(i=0;i<128;i++)
			{
				fprintf(fp,"%x %x %x %x\n", gDataRevBuffer[i*4], gDataRevBuffer[i*4+1], gDataRevBuffer[i*4+2], gDataRevBuffer[i*4+3]);
			}
		}
	
}


void CAdf7242Dlg::OnOK() 
{
	// TODO: Add extra validation here

	char filename[256];
	char devName[64] = "";

	strcat(devName,"\\\\.\\EZUSB-0");   //devNameΪ豸ҪFX2̼еUSBһ	
	
	m_hDevice = CreateFile(devName,		
		GENERIC_WRITE | GENERIC_READ,		
		FILE_SHARE_WRITE | FILE_SHARE_READ,		
		NULL,		
		OPEN_EXISTING,		
		FILE_ATTRIBUTE_NORMAL,		
		NULL);
	
	if (m_hDevice == INVALID_HANDLE_VALUE)		
	{		 
		MessageBox("Device Open Unsuccessfully!");
		return;
	}
	else
	{		

		if(!fp)
		{
			m_Path.GetWindowText(filename, 256);
			fp = fopen(filename, "w");
			if(fp == NULL) {
			MessageBox("File Created Unsuccessfully!");
			return ;
			}
		}

	SetTimer(1,100,NULL);
	AfxMessageBox("Device Open Successfully! Starting receiving data!", MB_OK);
	}
					
//	CDialog::OnOK();
}
    
void CAdf7242Dlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	if(fp)
	{
		MessageBox("Data file is saved!!");
		fclose(fp);
	}		
	CDialog::OnCancel();
}


void CAdf7242Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	ReadUSBData();	
	SetDlgItemText(IDC_EDIT_DATA, Newdata);
	CDialog::OnTimer(nIDEvent);
}
